'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _BaseInput2 = require('./abstract/BaseInput');

var _BaseInput3 = _interopRequireDefault(_BaseInput2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Input = function (_BaseInput) {
    _inherits(Input, _BaseInput);

    function Input(props) {
        _classCallCheck(this, Input);

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Input).call(this, props));

        _this.state = _lodash2.default.pick(props, ["value", "checked", "type", "disabled", "required"]);

        _this._onMouseEnter = _this._onMouseEnter.bind(_this);
        _this._onMouseLeave = _this._onMouseLeave.bind(_this);
        _this._onChange = _this._onChange.bind(_this);
        return _this;
    }

    _createClass(Input, [{
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps, prevState) {
            if (typeof this.state.value != 'undefined' && this.state.value != prevState.value || typeof this.state.checked != 'undefined' && this.state.checked != prevState.checked) {
                this.props.changeCallback();
            }
        }
    }, {
        key: '_onChange',
        value: function _onChange(e) {
            var value = e.target.value;
            var checked = e.target.checked;

            if (this.state.checked != checked || this.state.value != value) {
                this.setState({
                    value: value,
                    checked: checked
                });
            }
        }
    }, {
        key: '_onMouseEnter',
        value: function _onMouseEnter(e) {
            this.props.mouseEnterCallback();
        }
    }, {
        key: '_onMouseLeave',
        value: function _onMouseLeave(e) {
            this.props.mouseLeaveCallback();
        }
    }, {
        key: 'disabled',
        value: function disabled(v) {
            if (typeof v === 'undefined') {
                return this.state.disabled;
            } else {
                this.setState({ disabled: v });
            }
        }
    }, {
        key: 'required',
        value: function required(v) {
            if (typeof v === 'undefined') {
                return this.state.required;
            } else {
                this.setState({ required: v });
            }
        }
    }, {
        key: 'value',
        value: function value(v) {
            if (typeof v === 'undefined') {
                return this.state.value;
            } else {
                this.setState({ value: v });
            }
        }
    }, {
        key: 'checked',
        value: function checked(v) {
            if (typeof v === 'undefined') {
                return this.state.checked;
            } else {
                this.setState({ checked: v });
            }
        }
    }, {
        key: 'type',
        value: function type() {
            return this.state.type;
        }
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props;
            var validate = _props.validate;
            var extraClass = _props.extraClass;
            var type = _props.type;
            var disabled = _props.disabled;
            var required = _props.required;
            var value = _props.value;
            var checked = _props.checked;
            var mouseEnterCallback = _props.mouseEnterCallback;
            var mouseLeaveCallback = _props.mouseLeaveCallback;
            var changeCallback = _props.changeCallback;
            var label = _props.label;
            var errorMessage = _props.errorMessage;
            var successMessage = _props.successMessage;
            var withGap = _props.withGap;
            var offLabel = _props.offLabel;
            var onLabel = _props.onLabel;
            var blurCallback = _props.blurCallback;
            var focusCallback = _props.focusCallback;

            var other = _objectWithoutProperties(_props, ['validate', 'extraClass', 'type', 'disabled', 'required', 'value', 'checked', 'mouseEnterCallback', 'mouseLeaveCallback', 'changeCallback', 'label', 'errorMessage', 'successMessage', 'withGap', 'offLabel', 'onLabel', 'blurCallback', 'focusCallback']);

            var classes = (validate ? "validate " : "") + extraClass;

            return _react2.default.createElement('input', _extends({}, other, {
                type: this.state.type,
                disabled: this.state.disabled,
                required: this.state.required,
                checked: this.state.checked,
                value: this.state.value,
                onChange: this._onChange,
                onClick: this._onChange,
                onMouseEnter: this._onMouseEnter,
                onMouseLeave: this._onMouseLeave,
                onBlur: blurCallback,
                onFocus: focusCallback,
                className: classes }));
        }
    }]);

    return Input;
}(_BaseInput3.default);

exports.default = Input;


Input.displayName = "GenericInputElement";
Input.propTypes = {
    checked: _react2.default.PropTypes.bool,
    disabled: _react2.default.PropTypes.bool,
    required: _react2.default.PropTypes.bool,
    validate: _react2.default.PropTypes.bool,
    value: _react2.default.PropTypes.string,
    name: _react2.default.PropTypes.string,
    placeholder: _react2.default.PropTypes.string,
    id: _react2.default.PropTypes.string,
    type: _react2.default.PropTypes.oneOf(_BaseInput3.default.TYPES),
    extraClass: _react2.default.PropTypes.string,
    changeCallback: _react2.default.PropTypes.func,
    mouseEnterCallback: _react2.default.PropTypes.func,
    mouseLeaveCallback: _react2.default.PropTypes.func,
    blurCallback: _react2.default.PropTypes.func,
    focusCallback: _react2.default.PropTypes.func
};
Input.defaultProps = {
    checked: false,
    disabled: false,
    required: false,
    validate: false,
    value: '',
    name: '',
    placeholder: '',
    id: '',
    type: 'text',
    extraClass: '',
    changeCallback: function changeCallback() {},
    mouseEnterCallback: function mouseEnterCallback() {},
    mouseLeaveCallback: function mouseLeaveCallback() {},
    blurCallback: function blurCallback() {},
    focusCallback: function focusCallback() {}
};