'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _baseInputWrapper = require('./baseInputWrapper');

var _baseInputWrapper2 = _interopRequireDefault(_baseInputWrapper);

var _input = require('./input');

var _input2 = _interopRequireDefault(_input);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var InputBox = function (_BaseInputWrapper) {
    _inherits(InputBox, _BaseInputWrapper);

    function InputBox(props) {
        _classCallCheck(this, InputBox);

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(InputBox).call(this, props));

        _this._onBlur = _this._onBlur.bind(_this);
        _this._onFocus = _this._onFocus.bind(_this);

        _this.state = {
            active: !!props.value
        };
        return _this;
    }

    _createClass(InputBox, [{
        key: '_onFocus',
        value: function _onFocus() {
            this.setState({
                active: true
            });
        }
    }, {
        key: '_onBlur',
        value: function _onBlur() {
            this.setState({
                active: !!(this.refs.input.value() || this.props.placeholder)
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props;
            var errorMessage = _props.errorMessage;
            var successMessage = _props.successMessage;
            var label = _props.label;

            var other = _objectWithoutProperties(_props, ['errorMessage', 'successMessage', 'label']);

            other.blurCallback = this._onBlur;
            other.focusCallback = this._onFocus;

            var labelClass = this.state.active ? 'active' : '';

            return _react2.default.createElement(
                'div',
                { className: 'input-field col s12' },
                _react2.default.createElement(_input2.default, _extends({}, other, { ref: 'input' })),
                _react2.default.createElement('label', { htmlFor: other.id,
                    className: labelClass,
                    'data-error': errorMessage,
                    'data-success': successMessage,
                    dangerouslySetInnerHTML: { __html: label } })
            );
        }
    }]);

    return InputBox;
}(_baseInputWrapper2.default);

exports.default = InputBox;


InputBox.displayName = "InputBox";
InputBox.propTypes = {
    errorMessage: _react2.default.PropTypes.string,
    successMessage: _react2.default.PropTypes.string
};
InputBox.defaultProps = {
    errorMessage: '',
    successMessage: ''
};